class ReviewPolicy < ApplicationPolicy

  def create?
    record if user_exists?
  end

  def update?
    record if own?
  end

  def destroy?
    record if own?
  end

  def rate?
    record if user_exists?
  end

  private

  def own?
    record.user == user
  end
end
